Index: /branches/network/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- /branches/network/src/world_entities/weapons/targeting_turret.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/targeting_turret.cc	(revision 6693)
@@ -81,5 +81,5 @@
   this->setStateDuration(WS_DEACTIVATING, .4);
 
-  this->setMaximumEnergy(10000, 50);
+  this->setEnergyMax(10000);
   this->increaseEnergy(100000);
 
@@ -93,5 +93,9 @@
   this->target = new Aim(this);
   this->target->setVisibility(false);
-
+  this->target->setRange(100);
+  this->target->setAngle(M_PI_4/2);
+  this->lockedTime = 0;
+  this->neededLockTime = 2;
+  this->lockedTarget->setParent(PNode::getNullParent());
   this->loadModel("models/guns/turret2.obj");
 
@@ -120,6 +124,17 @@
 void TargetingTurret::tick(float dt)
 {
+  if( lockedTime >= neededLockTime )
+   {
+    lockedTarget = this->target->getParent();
+    lockedTime = 0;
+   }
 
   this->target->tick(dt);
+
+  if(this->target->getParent() == PNode::getNullParent())
+   lockedTime = 0;
+  else
+   lockedTime += dt;
+
 }
 
@@ -138,5 +153,5 @@
   pj->setAbsDir(this->getAbsDir());
   pj->activate();
-  this->target->searchTarget(100);
+  this->target->searchTarget();
 }
 
Index: /branches/network/src/world_entities/weapons/targeting_turret.h
===================================================================
--- /branches/network/src/world_entities/weapons/targeting_turret.h	(revision 6692)
+++ /branches/network/src/world_entities/weapons/targeting_turret.h	(revision 6693)
@@ -32,6 +32,9 @@
 
   private:
-    Aim*          target;
-  };
+    Aim*           target;
+    PNode*         lockedTarget;
+    float          lockedTime;
+    float          neededLockTime;
+  }; 
 
 #endif /* _TARGETING_TURRET_H */
Index: /branches/network/src/world_entities/weapons/test_gun.cc
===================================================================
--- /branches/network/src/world_entities/weapons/test_gun.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/test_gun.cc	(revision 6693)
@@ -122,5 +122,5 @@
   this->setStateDuration(WS_DEACTIVATING, .4);
 
-  this->setMaximumEnergy(1000, 100);
+  this->setEnergyMax(1000);
   this->increaseEnergy(1000);
   //this->minCharge = 2;
Index: /branches/network/src/world_entities/weapons/turret.cc
===================================================================
--- /branches/network/src/world_entities/weapons/turret.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/turret.cc	(revision 6693)
@@ -86,5 +86,5 @@
   this->setStateDuration(WS_DEACTIVATING, .4);
 
-  this->setMaximumEnergy(100, 5);
+  this->setEnergyMax(100);
   this->increaseEnergy(100);
   //this->minCharge = 2;
Index: /branches/network/src/world_entities/weapons/weapon.cc
===================================================================
--- /branches/network/src/world_entities/weapons/weapon.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/weapon.cc	(revision 6693)
@@ -95,12 +95,9 @@
   this->maxCharge = 1.0;                           //< The maximum charge is also one unit.
 
-  this->energyLoaded = .0;                         //< How much energy is loaded in the Gun. (Weapons must be charged befor usage)
-  this->energyLoadedMax = 5.0;                     //< Each Weapon has a Maximum energy that can be charged onto it
-  this->energy = .0;                               //< The secondary Buffer (before we have to reload)
+  this->energy = 10;                               //< The secondary Buffer (before we have to reload)
   this->energyMax = 10.0;                          //< How much energy can be carried
   this->capability = WTYPE_ALL;                    //< The Weapon has all capabilities @see W_Capability.
 
   this->energyWidget = NULL;
-  this->energyLoadedWidget = NULL;
 
   // set this object to be synchronized over network
@@ -291,18 +288,4 @@
 }
 
-
-GLGuiWidget* Weapon::getLoadedEnergyWidget()
-{
-  if (this->energyLoadedWidget == NULL)
-  {
-    this->energyLoadedWidget = new GLGuiBar;
-    //this->energyLoadedWidget->setParent2D(this->bar);
-    this->energyLoadedWidget->setRelCoor2D(20,0);
-    this->energyLoadedWidget->setSize2D(10,50);
-    this->energyLoadedWidget->setMaximum(this->getLoadedEnergyMax());
-  }
-  return this->energyLoadedWidget;
-}
-
 void Weapon::updateWidgets()
 {
@@ -311,9 +294,4 @@
     this->energyWidget->setMaximum(this->energyMax);
     this->energyWidget->setValue(this->energy);
-  }
-  if (this->energyLoadedWidget != NULL)
-  {
-    this->energyLoadedWidget->setMaximum(this->energyLoadedMax);
-    this->energyLoadedWidget->setValue(this->energyLoaded);
   }
 }
@@ -395,19 +373,19 @@
   switch (action)
   {
-    case WA_SHOOT:
-      return this->fireW();
-      break;
-    case WA_CHARGE:
-      return this->chargeW();
-      break;
-    case WA_RELOAD:
-      return this->reloadW();
-      break;
-    case WA_DEACTIVATE:
-      return this->deactivateW();
-      break;
-    case WA_ACTIVATE:
-      return this->activateW();
-      break;
+  case WA_SHOOT:
+    return this->fireW();
+    break;
+  case WA_CHARGE:
+    return this->chargeW();
+    break;
+  case WA_RELOAD:
+    return this->reloadW();
+    break;
+  case WA_DEACTIVATE:
+    return this->deactivateW();
+    break;
+  case WA_ACTIVATE:
+    return this->activateW();
+    break;
   }
 }
@@ -457,5 +435,5 @@
 bool Weapon::chargeW()
 {
-  if ( this->currentState != WS_INACTIVE && this->energyLoaded >= this->minCharge)
+  if ( this->currentState != WS_INACTIVE && this->energy >= this->minCharge)
   {
     // playing Sound
@@ -481,5 +459,5 @@
 {
   //if (likely(this->currentState != WS_INACTIVE))
-  if (this->minCharge <= this->energyLoaded)
+  if (this->minCharge <= this->energy)
   {
     // playing Sound
@@ -488,5 +466,5 @@
     this->updateWidgets();
     // fire
-    this->energyLoaded -= this->minCharge;
+    this->energy -= this->minCharge;
     this->fire();
     // setting up for the next state
@@ -507,5 +485,6 @@
 {
   PRINTF(4)("Reloading Weapon %s\n", this->getName());
-  if (unlikely(this->energy + this->energyLoaded < this->minCharge))
+  if (this->ammoContainer.get() != NULL &&
+        unlikely(this->energy + this->ammoContainer->getStoredEnergy() < this->minCharge))
   {
     this->requestAction(WA_DEACTIVATE);
@@ -514,22 +493,14 @@
   }
 
-  float chargeSize = this->energyLoadedMax - this->energyLoaded;       //!< The energy to be charged
 
   if (this->soundBuffers[WA_RELOAD] != NULL)
     this->soundSource->play(this->soundBuffers[WA_RELOAD]);
 
-  if (chargeSize > this->energy)
-  {
-    this->energyLoaded += this->energy;
-    this->energy = 0.0;
-    PRINT(5)("Energy depleted\n");
-  }
-  else
-  {
-    PRINTF(5)("Loaded %f energy into the Guns Buffer\n", chargeSize);
-    this->energyLoaded += chargeSize;
-    this->energy -= chargeSize;
-  }
-
+  if (this->ammoContainer.get() != NULL)
+    this->ammoContainer->fillWeapon(this);
+  else
+  {
+    this->energy = this->energyMax;
+  }
   this->updateWidgets();
   this->reload();
@@ -617,6 +588,6 @@
 {
   PRINT(0)("Weapon-Debug %s, state: %s (duration: %fs), nextAction: %s\n", this->getName(), Weapon::stateToChar(this->currentState), this->stateDuration, Weapon::actionToChar(requestedAction));
-  PRINT(0)("Energy: max: %f; current: %f;  loadedMax: %f; loadedCurrent: %f; chargeMin: %f, chargeMax %f\n",
-           this->energyMax, this->energy, this->energyLoadedMax, this->energyLoaded, this->minCharge, this->maxCharge);
+  PRINT(0)("Energy: max: %f; current: %f; chargeMin: %f, chargeMax %f\n",
+           this->energyMax, this->energy, this->minCharge, this->maxCharge);
 
 
@@ -663,25 +634,25 @@
   switch (action)
   {
-    case WA_SHOOT:
-      return "shoot";
-      break;
-    case WA_CHARGE:
-      return "charge";
-      break;
-    case WA_RELOAD:
-      return "reload";
-      break;
-    case WA_ACTIVATE:
-      return "activate";
-      break;
-    case WA_DEACTIVATE:
-      return "deactivate";
-      break;
-    case WA_SPECIAL1:
-      return "special1";
-      break;
-    default:
-      return "none";
-      break;
+  case WA_SHOOT:
+    return "shoot";
+    break;
+  case WA_CHARGE:
+    return "charge";
+    break;
+  case WA_RELOAD:
+    return "reload";
+    break;
+  case WA_ACTIVATE:
+    return "activate";
+    break;
+  case WA_DEACTIVATE:
+    return "deactivate";
+    break;
+  case WA_SPECIAL1:
+    return "special1";
+    break;
+  default:
+    return "none";
+    break;
   }
 }
@@ -726,28 +697,28 @@
   switch (state)
   {
-    case WS_SHOOTING:
-      return "shooting";
-      break;
-    case WS_CHARGING:
-      return "charging";
-      break;
-    case WS_RELOADING:
-      return "reloading";
-      break;
-    case WS_ACTIVATING:
-      return "activating";
-      break;
-    case WS_DEACTIVATING:
-      return "deactivating";
-      break;
-    case WS_IDLE:
-      return "idle";
-      break;
-    case WS_INACTIVE:
-      return "inactive";
-      break;
-    default:
-      return "none";
-      break;
-  }
-}
+  case WS_SHOOTING:
+    return "shooting";
+    break;
+  case WS_CHARGING:
+    return "charging";
+    break;
+  case WS_RELOADING:
+    return "reloading";
+    break;
+  case WS_ACTIVATING:
+    return "activating";
+    break;
+  case WS_DEACTIVATING:
+    return "deactivating";
+    break;
+  case WS_IDLE:
+    return "idle";
+    break;
+  case WS_INACTIVE:
+    return "inactive";
+    break;
+  default:
+    return "none";
+    break;
+  }
+}
Index: /branches/network/src/world_entities/weapons/weapon.h
===================================================================
--- /branches/network/src/world_entities/weapons/weapon.h	(revision 6692)
+++ /branches/network/src/world_entities/weapons/weapon.h	(revision 6693)
@@ -16,4 +16,6 @@
 
 #include "world_entity.h"
+#include "count_pointer.h"
+#include "ammo_container.h"
 
 // FORWARD DECLARATION
@@ -105,5 +107,5 @@
     inline void setCapability(long capabilities) { this->capability = capabilities; };
     /** @returns the Capabilities of this Weapon */
-    inline long getCapability() { return this->capability; };
+    inline long getCapability() const { return this->capability; };
     void setProjectileType(ClassID projectile);
     void setProjectileType(const char* projectile);
@@ -135,10 +137,9 @@
     inline WeaponState getCurrentState() const { return this->currentState; };
 
-    /** @param energyMax the maximum energy the Weapon can have @param energyLoadedMax the maximum energy in the weapon buffers */
-    inline void setMaximumEnergy(float energyMax, float energyLoadedMax) { this->energyMax = energyMax; this->energyLoadedMax = energyLoadedMax; };
-    inline float getLoadedEnergyMax() const { return this->energyLoadedMax; };
+    /** @param energyMax the maximum energy the Weapon can have */
+    inline void setEnergyMax(float energyMax) { this->energyMax = energyMax; };
+    inline float getEnergy() const { return this->energy; };
     inline float getEnergyMax() const { return this->energyMax; };
-    inline float getEnergy() const { return this->energy; };
-    inline float getLoadedEnergy() const { return this->energyLoaded; };
+    inline void setAmmoContainer(const CountPointer<AmmoContainer>& ammoContainer) { this->ammoContainer = ammoContainer;}
 
     void setActionSound(WeaponAction action, const char* soundFile);
@@ -150,5 +151,4 @@
 
     GLGuiWidget* getEnergyWidget();
-    GLGuiWidget* getLoadedEnergyWidget();
 
     // FLOW
@@ -198,8 +198,7 @@
 
     // it is all about energy
-    float                energy;                           //!< The energy stored in the weapons secondary buffers (reserve)
-    float                energyLoaded;                     //!< The energy stored in the weapons primary buffers (fire without reload)
+    float                energy;                           //!< The energy stored in the weapons buffers
     float                energyMax;                        //!< The maximal energy that can be stored in the secondary buffers (reserveMax)
-    float                energyLoadedMax;                  //!< The maximal energy that can be stored in the primary buffers
+    CountPointer<AmmoContainer> ammoContainer;             //!< Pointer to the AmmoContainer this weapon grabs Energy from.
     //! @todo move this to projectile
     float                minCharge;                        //!< The minimal energy to be loaded onto one projectile if chargeable otherwise the power consumed by one projectile
@@ -207,5 +206,4 @@
 
     GLGuiBar*            energyWidget;
-    GLGuiBar*            energyLoadedWidget;
 
     ////////////
Index: /branches/network/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- /branches/network/src/world_entities/weapons/weapon_manager.cc	(revision 6692)
+++ /branches/network/src/world_entities/weapons/weapon_manager.cc	(revision 6693)
@@ -217,14 +217,32 @@
 bool WeaponManager::addWeapon(Weapon* weapon, int configID, int slotID)
 {
+  assert(weapon != NULL);
+
   if (unlikely(configID >= WM_MAX_CONFIGS || slotID >= (int)this->slotCount))
   {
-    PRINTF(2)("Slot %d of config %d is not availiabe (max: %d)\n", slotID, configID, this->slotCount);
+    PRINTF(2)("Slot %d of config %d is not availiabe (max: %d) searching for suitable slot\n", slotID, configID, this->slotCount);
+    if (configID >= WM_MAX_CONFIGS)
+      configID = -1;
+    if (slotID >= (int)this->slotCount)
+      slotID = -1;
+  }
+  // if no ConfigID is supplied set to Current Config.
+  if (configID <= -1)
+    configID = this->currentConfigID;
+  //
+  if (configID > -1 && slotID == -1)
+  {
+    slotID = this->getNextFreeSlot(configID, weapon->getCapability());
+    if (slotID == -1)
+      configID = -1;
+  }
+
+  if (configID > 0 && slotID > 0 && this->configs[configID][slotID] != NULL)
+  {
+    PRINTF(3)("Weapon-slot %d/%d of %s already poulated, remove weapon (%s::%s) first\n", configID, slotID, this->getName(), weapon->getClassName(), weapon->getName());
     return false;
   }
 
-  if (this->configs[configID][slotID] != NULL && configID > 0 && slotID > 0)
-    PRINTF(3)("Weapon-slot %d/%d of %s already poulated, overwriting\n", configID, slotID, this->getName());
-
-  if (slotID == -1) // WM_FREE_SLOT
+  if (slotID <= -1) // WM_FREE_SLOT
   {
     slotID = this->getNextFreeSlot(configID, weapon->getCapability());
@@ -245,10 +263,13 @@
 
   //! @todo check if the weapon is already assigned to another config in another slot
+  assert(this->configs[configID][slotID] == NULL);
+
   this->configs[configID][slotID] = weapon;
+  weapon->setAmmoContainer(this->getAmmoContainer(weapon->getProjectileType()));
   if (this->parent != NULL)
   {
     this->parent->addChild(weapon);
   }
-  PRINTF(3)("Added a new Weapon to the WeaponManager: config %i/ slot %i\n", configID, slotID);
+  PRINTF(3)("Added a new Weapon (%s::%s) to the WeaponManager: config %i/ slot %i\n", weapon->getClassName(), weapon->getName(), configID, slotID);
   return true;
 }
@@ -420,18 +441,42 @@
 /**
  * private gets the next free slot in a certain weaponconfig
- * @param the selected weaponconfig
+ * @param the selected weaponconfig -1 if none found
  */
 int WeaponManager::getNextFreeSlot(int configID, long capability)
 {
-  for( int i = 0; i < this->slotCount; ++i)
-  {
-    if( this->configs[configID][i] == NULL &&
-        (this->currentSlotConfig[i].capability & capability & WTYPE_ALLKINDS) &&
-        (this->currentSlotConfig[i].capability & capability & WTYPE_ALLDIRS))
-      return i;
+  if (configID == -1)
+  {
+    for (configID = 0; configID < WM_MAX_CONFIGS; configID++)
+      for( int i = 0; i < this->slotCount; ++i)
+      {
+        if( this->configs[configID][i] == NULL &&
+            (this->currentSlotConfig[i].capability & capability & WTYPE_ALLKINDS) &&
+            (this->currentSlotConfig[i].capability & capability & WTYPE_ALLDIRS))
+          return i;
+    }
+  }
+  else
+  {
+    for( int i = 0; i < this->slotCount; ++i)
+    {
+      if( this->configs[configID][i] == NULL &&
+          (this->currentSlotConfig[i].capability & capability & WTYPE_ALLKINDS) &&
+          (this->currentSlotConfig[i].capability & capability & WTYPE_ALLDIRS))
+        return i;
+    }
   }
   return -1;
 }
 
+CountPointer<AmmoContainer>& WeaponManager::getAmmoContainer(ClassID projectileType)
+{
+  for (unsigned int i = 0; i < this->ammo.size(); i++)
+  {
+    if (this->ammo[i]->getProjectileType() == projectileType)
+      return this->ammo[i];
+  }
+  this->ammo.push_back(CountPointer<AmmoContainer>(new AmmoContainer(projectileType)));
+  return this->ammo.back();
+}
 
 
Index: /branches/network/src/world_entities/weapons/weapon_manager.h
===================================================================
--- /branches/network/src/world_entities/weapons/weapon_manager.h	(revision 6692)
+++ /branches/network/src/world_entities/weapons/weapon_manager.h	(revision 6693)
@@ -17,4 +17,7 @@
 #include "crosshair.h"
 #include "weapon.h"
+
+#include "count_pointer.h"
+#include "ammo_container.h"
 
 // FORWARD DECLARATION
@@ -71,7 +74,7 @@
     PNode* getParent() const { return this->parent; };
 
-    bool addWeapon(Weapon* weapon);
     bool addWeapon(Weapon* weapon, int configID = -1, int slotID = -1);
     void removeWeapon(Weapon* weapon, int configID = -1);
+
     Weapon* getWeapon(int slotID) const { return (slotID >= 0 && slotID < this->slotCount)? this->currentSlotConfig[slotID].nextWeapon: NULL; };
 
@@ -82,4 +85,7 @@
     void previousWeaponConfig();
     void changeWeaponConfig(int weaponConfig);
+
+    float addAmmunition(ClassID projectileType, float ammo);
+
 
     /** @returns a fixed target namely the Crosshair's 3D position */
@@ -97,4 +103,5 @@
  // private:
     int getNextFreeSlot(int configID, long capability = WTYPE_ALL);
+    CountPointer<AmmoContainer>& getAmmoContainer(ClassID projectileType);
 
   private:
@@ -112,4 +119,6 @@
     Crosshair*              crosshair;                                //!< an aim.
     tAnimation<Crosshair>*  crossHairSizeAnim;                        //!< An animation for the crosshair (scaling)
+
+    std::vector<CountPointer<AmmoContainer> > ammo;                   //!< Containers
 };
 
